//
//  MBAppleScriptApplication.h
//  MBAppleScriptBridge
//
//	A class to represent the main application object in an application's Apple Script dictionary.
//	Thread safe.
//
//  Created by Milo on 27/12/2006.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "MBAppleScriptObject.h"
@class MBProcessSerialNumber;


@interface MBAppleScriptApplication : MBAppleScriptObject 
{
	NSString *_name;
	MBProcessSerialNumber *_processSerialNumber;
	BOOL _shouldUseCacheDefault;
}

+ (id)applicationWithName:(NSString *)name shouldUseCacheDefault:(BOOL)shouldUseCacheDefault;
- (id)initWithName:(NSString *)name shouldUseCacheDefault:(BOOL)shouldUseCacheDefault;	// Designated initialiser

- (NSString *)name;
- (NSBundle *)bundle;

- (BOOL)shouldUseCacheDefault;	// The initial cache setting of all MBAppleScriptObject instances associated with this application
- (void)setShouldUseCacheDefault:(BOOL)newDefault;
@end


@interface NSObject (MBAppleScriptApplicationNotifications)

- (void)appleScriptApplicationDidLaunch:(NSNotification *)notification;
- (void)appleScriptApplicationDidTerminate:(NSNotification *)notification;
@end

// Notifications
extern NSString *MBAppleScriptApplicationDidLaunchNotification;
extern NSString *MBAppleScriptApplicationDidTerminateNotification;

