#import "MBAppleScriptObject.h"


@interface MBAppleScriptObject (Private)

- (id)_initWithObjectSpecifier:(NSAppleEventDescriptor *)objectSpecifier application:(MBAppleScriptApplication *)application shouldUseCache:(BOOL)shouldUseCache;	// Designated initialiser

- (NSAppleEventDescriptor *)_objectSpecifier;
- (void)_setObjectSpecifier:(NSAppleEventDescriptor *)newObjectSpecifier;
- (void)_setApplication:(MBAppleScriptApplication *)newApplication;

- (id)_cachedValueForType:(OSType)type;
- (void)_setCachedValue:(id)value forType:(OSType)type;
@end


@interface NSAppleEventDescriptor (MBAppleScriptObject)

+ (NSAppleEventDescriptor *)appleEventWithTargetDescriptor:(NSAppleEventDescriptor *)targetDescriptor eventClass:(AEEventClass)eventClass eventID:(AEEventID)eventID;
+ (NSAppleEventDescriptor *)descriptorWithExmnType;
+ (NSAppleEventDescriptor *)descriptorWithAbsoCode:(OSType)ordinalCode;

+ (NSAppleEventDescriptor *)descriptorWithCocoaEquivalent:(id)object;
- (id)cocoaEquivalent:(MBAppleScriptObject *)sender;

- (NSAppleEventDescriptor *)sendWithImmediateReply;
- (NSAppleEventDescriptor *)directObject;
@end
