//
//  MBOSType.m
//  iTunesInterfaceTest
//
//  Created by Milo on 23/12/2006.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "MBType.h"


@implementation MBType

+ (id)typeWithOSType:(OSType)type;
{
	return [[[self alloc] initWithOSType:type] autorelease];
}

- (id)initWithOSType:(OSType)type;	// Designated initialiser
{
	if ([super init] == nil)
		return nil;
		
	_OSType = type;
	
	return self;
}

// NSObject
- (id)init;
{
	return [self initWithOSType:0];
}

// NSObject
- (unsigned)hash;
{
	return (unsigned)[self OSType];
}

// NSObject
- (BOOL)isEqual:(id)object;
{
	if (object == nil || [object isKindOfClass:[self class]] == NO)
		return NO;
	else return [self isEqualToType:object];
}

- (BOOL)isEqualToType:(MBType *)someType;
{
	if (someType == nil)
		return NO;
	if (someType == self)
		return YES;
	if ([someType OSType] == [self OSType])
		return YES;
	else return NO;
}

- (OSType)OSType;
{
	return _OSType;
}

// <NSCopying>
- (id)copyWithZone:(NSZone *)theZone;
{
	return [self retain];
}

@end
